// FullAccess
resource "azurerm_role_definition" "data_factory_fullaccess_definition" {
  name              = "data-factory-fullaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.DataFactory/register/action",
      "Microsoft.DataFactory/unregister/action",
      "Microsoft.DataFactory/datafactories/read",
      "Microsoft.DataFactory/datafactories/write",
      "Microsoft.DataFactory/datafactories/delete",
      "Microsoft.DataFactory/datafactories/linkedServices/read",
      "Microsoft.DataFactory/datafactories/linkedServices/delete",
      "Microsoft.DataFactory/datafactories/linkedServices/write",
      "Microsoft.DataFactory/datafactories/datapipelines/read",
      "Microsoft.DataFactory/datafactories/datapipelines/delete",
      "Microsoft.DataFactory/datafactories/datapipelines/pause/action",
      "Microsoft.DataFactory/datafactories/datapipelines/resume/action",
      "Microsoft.DataFactory/datafactories/datapipelines/update/action",
      "Microsoft.DataFactory/datafactories/datapipelines/write",
      "Microsoft.DataFactory/datafactories/datasets/read",
      "Microsoft.DataFactory/datafactories/datasets/delete",
      "Microsoft.DataFactory/datafactories/datasets/write",
      "Microsoft.DataFactory/datafactories/tables/read",
      "Microsoft.DataFactory/datafactories/tables/delete",
      "Microsoft.DataFactory/datafactories/tables/write",
      "Microsoft.DataFactory/datafactories/datasets/slices/read",
      "Microsoft.DataFactory/datafactories/datasets/slices/write",
      "Microsoft.DataFactory/datafactories/datasets/sliceruns/read",
      "Microsoft.DataFactory/datafactories/runs/loginfo/read",
      "Microsoft.DataFactory/datafactories/activitywindows/read",
      "Microsoft.DataFactory/datafactories/datapipelines/activitywindows/read",
      "Microsoft.DataFactory/datafactories/datapipelines/activities/activitywindows/read",
      "Microsoft.DataFactory/datafactories/datasets/activitywindows/read",
      "Microsoft.DataFactory/datafactories/gateways/read",
      "Microsoft.DataFactory/datafactories/gateways/write",
      "Microsoft.DataFactory/datafactories/gateways/delete",
      "Microsoft.DataFactory/datafactories/gateways/connectioninfo/action",
      "Microsoft.DataFactory/datafactories/gateways/listauthkeys/action",
      "Microsoft.DataFactory/datafactories/gateways/regenerateauthkey/action",
      "Microsoft.DataFactory/factories/read",
      "Microsoft.DataFactory/factories/write",
      "Microsoft.DataFactory/factories/delete",
      "Microsoft.DataFactory/factories/createdataflowdebugsession/action",
      "Microsoft.DataFactory/factories/startdataflowdebugsession/action",
      "Microsoft.DataFactory/factories/deletedataflowdebugsession/action",
      "Microsoft.DataFactory/factories/cancelpipelinerun/action",
      "Microsoft.DataFactory/factories/getFeatureValue/action",
      "Microsoft.DataFactory/factories/getDataPlaneAccess/action",
      "Microsoft.DataFactory/factories/getGitHubAccessToken/action",
      "Microsoft.DataFactory/factories/querytriggerruns/action",
      "Microsoft.DataFactory/factories/querypipelineruns/action",
      "Microsoft.DataFactory/factories/querydebugpipelineruns/action",
      "Microsoft.DataFactory/factories/linkedServices/read",
      "Microsoft.DataFactory/factories/linkedServices/delete",
      "Microsoft.DataFactory/factories/linkedServices/write",
      "Microsoft.DataFactory/factories/pipelines/read",
      "Microsoft.DataFactory/factories/pipelines/delete",
      "Microsoft.DataFactory/factories/pipelines/write",
      "Microsoft.DataFactory/factories/pipelines/createrun/action",
      "Microsoft.DataFactory/factories/pipelineruns/read",
      "Microsoft.DataFactory/factories/pipelineruns/cancel/action",
      "Microsoft.DataFactory/factories/pipelineruns/queryactivityruns/action",
      "Microsoft.DataFactory/factories/pipelineruns/activityruns/read",
      "Microsoft.DataFactory/factories/datasets/read",
      "Microsoft.DataFactory/factories/datasets/delete",
      "Microsoft.DataFactory/factories/datasets/write",
      "Microsoft.DataFactory/factories/integrationruntimes/read",
      "Microsoft.DataFactory/factories/integrationruntimes/write",
      "Microsoft.DataFactory/factories/integrationruntimes/delete",
      "Microsoft.DataFactory/factories/integrationruntimes/start/action",
      "Microsoft.DataFactory/factories/integrationruntimes/stop/action",
      "Microsoft.DataFactory/factories/integrationruntimes/synccredentials/action",
      "Microsoft.DataFactory/factories/integrationruntimes/upgrade/action",
      "Microsoft.DataFactory/factories/integrationruntimes/regenerateauthkey/action",
      "Microsoft.DataFactory/factories/integrationruntimes/removelinks/action",
      "Microsoft.DataFactory/factories/integrationruntimes/linkedIntegrationRuntime/action",
      "Microsoft.DataFactory/factories/integrationruntimes/getObjectMetadata/action",
      "Microsoft.DataFactory/factories/integrationruntimes/refreshObjectMetadata/action",
      "Microsoft.DataFactory/factories/integrationruntimes/getconnectioninfo/read",
      "Microsoft.DataFactory/factories/integrationruntimes/getstatus/read",
      "Microsoft.DataFactory/factories/integrationruntimes/listauthkeys/read",
      "Microsoft.DataFactory/factories/integrationruntimes/monitoringdata/read",
      "Microsoft.DataFactory/factories/integrationruntimes/nodes/read",
      "Microsoft.DataFactory/factories/integrationruntimes/nodes/delete",
      "Microsoft.DataFactory/factories/integrationruntimes/nodes/write",
      "Microsoft.DataFactory/factories/integrationruntimes/nodes/ipAddress/action",
      "Microsoft.DataFactory/factories/triggers/read",
      "Microsoft.DataFactory/factories/triggers/write",
      "Microsoft.DataFactory/factories/triggers/delete",
      "Microsoft.DataFactory/factories/triggers/start/action",
      "Microsoft.DataFactory/factories/triggers/stop/action",
      "Microsoft.DataFactory/factories/triggers/triggerruns/read",
      "Microsoft.DataFactory/locations/configureFactoryRepo/action",
      "Microsoft.DataFactory/locations/getFeatureValue/action",
      "Microsoft.DataFactory/factories/triggerruns/read",
      "Microsoft.DataFactory/factories/pipelines/pipelineruns/read",
      "Microsoft.DataFactory/factories/querytriggerruns/read",
      "Microsoft.DataFactory/factories/querypipelineruns/read",
      "Microsoft.DataFactory/factories/pipelineruns/queryactivityruns/read",
      "Microsoft.DataFactory/factories/pipelines/pipelineruns/activityruns/progress/read",
      "Microsoft.DataFactory/operations/read",
      "Microsoft.DataFactory/checkazuredatafactorynameavailability/read",
      "Microsoft.DataFactory/locations/getFeatureValue/read",
      "Microsoft.DataFactory/factories/dataflows/read",
      "Microsoft.DataFactory/factories/dataflows/delete",
      "Microsoft.DataFactory/factories/dataflows/write",
      "Microsoft.DataFactory/factories/getFeatureValue/read",
      "Microsoft.DataFactory/factories/getDataPlaneAccess/read",
    ]

    not_actions = []
  }
}

// ReadOnly
resource "azurerm_role_definition" "data_factory_readonly_definition" {
  name              = "data-factory-readonly-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = [
      "Microsoft.DataFactory/datafactories/read",
      "Microsoft.DataFactory/datafactories/linkedServices/read",
      "Microsoft.DataFactory/datafactories/datapipelines/read",
      "Microsoft.DataFactory/datafactories/datasets/read",
      "Microsoft.DataFactory/datafactories/tables/read",
      "Microsoft.DataFactory/datafactories/datasets/slices/read",
      "Microsoft.DataFactory/datafactories/datasets/sliceruns/read",
      "Microsoft.DataFactory/datafactories/runs/loginfo/read",
      "Microsoft.DataFactory/datafactories/activitywindows/read",
      "Microsoft.DataFactory/datafactories/datapipelines/activitywindows/read",
      "Microsoft.DataFactory/datafactories/datapipelines/activities/activitywindows/read",
      "Microsoft.DataFactory/datafactories/datasets/activitywindows/read",
      "Microsoft.DataFactory/datafactories/gateways/read",
      "Microsoft.DataFactory/factories/read",
      "Microsoft.DataFactory/factories/linkedServices/read",
      "Microsoft.DataFactory/factories/pipelines/read",
      "Microsoft.DataFactory/factories/pipelineruns/read",
      "Microsoft.DataFactory/factories/pipelineruns/activityruns/read",
      "Microsoft.DataFactory/factories/datasets/read",
      "Microsoft.DataFactory/factories/integrationruntimes/read",
      "Microsoft.DataFactory/factories/integrationruntimes/getconnectioninfo/read",
      "Microsoft.DataFactory/factories/integrationruntimes/getstatus/read",
      "Microsoft.DataFactory/factories/integrationruntimes/listauthkeys/read",
      "Microsoft.DataFactory/factories/integrationruntimes/monitoringdata/read",
      "Microsoft.DataFactory/factories/integrationruntimes/nodes/read",
      "Microsoft.DataFactory/factories/triggers/read",
      "Microsoft.DataFactory/factories/triggers/triggerruns/read",
      "Microsoft.DataFactory/factories/triggerruns/read",
      "Microsoft.DataFactory/factories/pipelines/pipelineruns/read",
      "Microsoft.DataFactory/factories/querytriggerruns/read",
      "Microsoft.DataFactory/factories/querypipelineruns/read",
      "Microsoft.DataFactory/factories/pipelineruns/queryactivityruns/read",
      "Microsoft.DataFactory/factories/pipelines/pipelineruns/activityruns/progress/read",
      "Microsoft.DataFactory/operations/read",
      "Microsoft.DataFactory/checkazuredatafactorynameavailability/read",
      "Microsoft.DataFactory/locations/getFeatureValue/read",
      "Microsoft.DataFactory/factories/dataflows/read",
      "Microsoft.DataFactory/factories/getFeatureValue/read",
      "Microsoft.DataFactory/factories/getDataPlaneAccess/read",
    ]

    not_actions = [
      "Microsoft.DataFactory/register/action",
      "Microsoft.DataFactory/unregister/action",
      "Microsoft.DataFactory/datafactories/write",
      "Microsoft.DataFactory/datafactories/delete",
      "Microsoft.DataFactory/datafactories/linkedServices/delete",
      "Microsoft.DataFactory/datafactories/linkedServices/write",
      "Microsoft.DataFactory/datafactories/datapipelines/delete",
      "Microsoft.DataFactory/datafactories/datapipelines/pause/action",
      "Microsoft.DataFactory/datafactories/datapipelines/resume/action",
      "Microsoft.DataFactory/datafactories/datapipelines/update/action",
      "Microsoft.DataFactory/datafactories/datapipelines/write",
      "Microsoft.DataFactory/datafactories/datasets/delete",
      "Microsoft.DataFactory/datafactories/datasets/write",
      "Microsoft.DataFactory/datafactories/tables/delete",
      "Microsoft.DataFactory/datafactories/tables/write",
      "Microsoft.DataFactory/datafactories/datasets/slices/write",
      "Microsoft.DataFactory/datafactories/gateways/write",
      "Microsoft.DataFactory/datafactories/gateways/delete",
      "Microsoft.DataFactory/datafactories/gateways/connectioninfo/action",
      "Microsoft.DataFactory/datafactories/gateways/listauthkeys/action",
      "Microsoft.DataFactory/datafactories/gateways/regenerateauthkey/action",
      "Microsoft.DataFactory/factories/write",
      "Microsoft.DataFactory/factories/delete",
      "Microsoft.DataFactory/factories/createdataflowdebugsession/action",
      "Microsoft.DataFactory/factories/startdataflowdebugsession/action",
      "Microsoft.DataFactory/factories/deletedataflowdebugsession/action",
      "Microsoft.DataFactory/factories/cancelpipelinerun/action",
      "Microsoft.DataFactory/factories/getFeatureValue/action",
      "Microsoft.DataFactory/factories/getDataPlaneAccess/action",
      "Microsoft.DataFactory/factories/getGitHubAccessToken/action",
      "Microsoft.DataFactory/factories/querytriggerruns/action",
      "Microsoft.DataFactory/factories/querypipelineruns/action",
      "Microsoft.DataFactory/factories/querydebugpipelineruns/action",
      "Microsoft.DataFactory/factories/linkedServices/delete",
      "Microsoft.DataFactory/factories/linkedServices/write",
      "Microsoft.DataFactory/factories/pipelines/delete",
      "Microsoft.DataFactory/factories/pipelines/write",
      "Microsoft.DataFactory/factories/pipelines/createrun/action",
      "Microsoft.DataFactory/factories/pipelineruns/cancel/action",
      "Microsoft.DataFactory/factories/pipelineruns/queryactivityruns/action",
      "Microsoft.DataFactory/factories/datasets/delete",
      "Microsoft.DataFactory/factories/datasets/write",
      "Microsoft.DataFactory/factories/integrationruntimes/write",
      "Microsoft.DataFactory/factories/integrationruntimes/delete",
      "Microsoft.DataFactory/factories/integrationruntimes/start/action",
      "Microsoft.DataFactory/factories/integrationruntimes/stop/action",
      "Microsoft.DataFactory/factories/integrationruntimes/synccredentials/action",
      "Microsoft.DataFactory/factories/integrationruntimes/upgrade/action",
      "Microsoft.DataFactory/factories/integrationruntimes/regenerateauthkey/action",
      "Microsoft.DataFactory/factories/integrationruntimes/removelinks/action",
      "Microsoft.DataFactory/factories/integrationruntimes/linkedIntegrationRuntime/action",
      "Microsoft.DataFactory/factories/integrationruntimes/getObjectMetadata/action",
      "Microsoft.DataFactory/factories/integrationruntimes/refreshObjectMetadata/action",
      "Microsoft.DataFactory/factories/integrationruntimes/nodes/delete",
      "Microsoft.DataFactory/factories/integrationruntimes/nodes/write",
      "Microsoft.DataFactory/factories/integrationruntimes/nodes/ipAddress/action",
      "Microsoft.DataFactory/factories/triggers/write",
      "Microsoft.DataFactory/factories/triggers/delete",
      "Microsoft.DataFactory/factories/triggers/start/action",
      "Microsoft.DataFactory/factories/triggers/stop/action",
      "Microsoft.DataFactory/locations/configureFactoryRepo/action",
      "Microsoft.DataFactory/locations/getFeatureValue/action",
      "Microsoft.DataFactory/factories/dataflows/delete",
      "Microsoft.DataFactory/factories/dataflows/write",
    ]
  }
}

// NoAccess
resource "azurerm_role_definition" "data_factory_noaccess_definition" {
  name              = "data-factory-noaccess-definition"
  scope             = "/subscriptions/${var.subscription_id}"
  assignable_scopes = "/subscriptions/${var.subscription_id}"

  permissions {
    actions = []

    not_actions = [
      "Microsoft.DataFactory/register/action",
      "Microsoft.DataFactory/unregister/action",
      "Microsoft.DataFactory/datafactories/read",
      "Microsoft.DataFactory/datafactories/write",
      "Microsoft.DataFactory/datafactories/delete",
      "Microsoft.DataFactory/datafactories/linkedServices/read",
      "Microsoft.DataFactory/datafactories/linkedServices/delete",
      "Microsoft.DataFactory/datafactories/linkedServices/write",
      "Microsoft.DataFactory/datafactories/datapipelines/read",
      "Microsoft.DataFactory/datafactories/datapipelines/delete",
      "Microsoft.DataFactory/datafactories/datapipelines/pause/action",
      "Microsoft.DataFactory/datafactories/datapipelines/resume/action",
      "Microsoft.DataFactory/datafactories/datapipelines/update/action",
      "Microsoft.DataFactory/datafactories/datapipelines/write",
      "Microsoft.DataFactory/datafactories/datasets/read",
      "Microsoft.DataFactory/datafactories/datasets/delete",
      "Microsoft.DataFactory/datafactories/datasets/write",
      "Microsoft.DataFactory/datafactories/tables/read",
      "Microsoft.DataFactory/datafactories/tables/delete",
      "Microsoft.DataFactory/datafactories/tables/write",
      "Microsoft.DataFactory/datafactories/datasets/slices/read",
      "Microsoft.DataFactory/datafactories/datasets/slices/write",
      "Microsoft.DataFactory/datafactories/datasets/sliceruns/read",
      "Microsoft.DataFactory/datafactories/runs/loginfo/read",
      "Microsoft.DataFactory/datafactories/activitywindows/read",
      "Microsoft.DataFactory/datafactories/datapipelines/activitywindows/read",
      "Microsoft.DataFactory/datafactories/datapipelines/activities/activitywindows/read",
      "Microsoft.DataFactory/datafactories/datasets/activitywindows/read",
      "Microsoft.DataFactory/datafactories/gateways/read",
      "Microsoft.DataFactory/datafactories/gateways/write",
      "Microsoft.DataFactory/datafactories/gateways/delete",
      "Microsoft.DataFactory/datafactories/gateways/connectioninfo/action",
      "Microsoft.DataFactory/datafactories/gateways/listauthkeys/action",
      "Microsoft.DataFactory/datafactories/gateways/regenerateauthkey/action",
      "Microsoft.DataFactory/factories/read",
      "Microsoft.DataFactory/factories/write",
      "Microsoft.DataFactory/factories/delete",
      "Microsoft.DataFactory/factories/createdataflowdebugsession/action",
      "Microsoft.DataFactory/factories/startdataflowdebugsession/action",
      "Microsoft.DataFactory/factories/deletedataflowdebugsession/action",
      "Microsoft.DataFactory/factories/cancelpipelinerun/action",
      "Microsoft.DataFactory/factories/getFeatureValue/action",
      "Microsoft.DataFactory/factories/getDataPlaneAccess/action",
      "Microsoft.DataFactory/factories/getGitHubAccessToken/action",
      "Microsoft.DataFactory/factories/querytriggerruns/action",
      "Microsoft.DataFactory/factories/querypipelineruns/action",
      "Microsoft.DataFactory/factories/querydebugpipelineruns/action",
      "Microsoft.DataFactory/factories/linkedServices/read",
      "Microsoft.DataFactory/factories/linkedServices/delete",
      "Microsoft.DataFactory/factories/linkedServices/write",
      "Microsoft.DataFactory/factories/pipelines/read",
      "Microsoft.DataFactory/factories/pipelines/delete",
      "Microsoft.DataFactory/factories/pipelines/write",
      "Microsoft.DataFactory/factories/pipelines/createrun/action",
      "Microsoft.DataFactory/factories/pipelineruns/read",
      "Microsoft.DataFactory/factories/pipelineruns/cancel/action",
      "Microsoft.DataFactory/factories/pipelineruns/queryactivityruns/action",
      "Microsoft.DataFactory/factories/pipelineruns/activityruns/read",
      "Microsoft.DataFactory/factories/datasets/read",
      "Microsoft.DataFactory/factories/datasets/delete",
      "Microsoft.DataFactory/factories/datasets/write",
      "Microsoft.DataFactory/factories/integrationruntimes/read",
      "Microsoft.DataFactory/factories/integrationruntimes/write",
      "Microsoft.DataFactory/factories/integrationruntimes/delete",
      "Microsoft.DataFactory/factories/integrationruntimes/start/action",
      "Microsoft.DataFactory/factories/integrationruntimes/stop/action",
      "Microsoft.DataFactory/factories/integrationruntimes/synccredentials/action",
      "Microsoft.DataFactory/factories/integrationruntimes/upgrade/action",
      "Microsoft.DataFactory/factories/integrationruntimes/regenerateauthkey/action",
      "Microsoft.DataFactory/factories/integrationruntimes/removelinks/action",
      "Microsoft.DataFactory/factories/integrationruntimes/linkedIntegrationRuntime/action",
      "Microsoft.DataFactory/factories/integrationruntimes/getObjectMetadata/action",
      "Microsoft.DataFactory/factories/integrationruntimes/refreshObjectMetadata/action",
      "Microsoft.DataFactory/factories/integrationruntimes/getconnectioninfo/read",
      "Microsoft.DataFactory/factories/integrationruntimes/getstatus/read",
      "Microsoft.DataFactory/factories/integrationruntimes/listauthkeys/read",
      "Microsoft.DataFactory/factories/integrationruntimes/monitoringdata/read",
      "Microsoft.DataFactory/factories/integrationruntimes/nodes/read",
      "Microsoft.DataFactory/factories/integrationruntimes/nodes/delete",
      "Microsoft.DataFactory/factories/integrationruntimes/nodes/write",
      "Microsoft.DataFactory/factories/integrationruntimes/nodes/ipAddress/action",
      "Microsoft.DataFactory/factories/triggers/read",
      "Microsoft.DataFactory/factories/triggers/write",
      "Microsoft.DataFactory/factories/triggers/delete",
      "Microsoft.DataFactory/factories/triggers/start/action",
      "Microsoft.DataFactory/factories/triggers/stop/action",
      "Microsoft.DataFactory/factories/triggers/triggerruns/read",
      "Microsoft.DataFactory/locations/configureFactoryRepo/action",
      "Microsoft.DataFactory/locations/getFeatureValue/action",
      "Microsoft.DataFactory/factories/triggerruns/read",
      "Microsoft.DataFactory/factories/pipelines/pipelineruns/read",
      "Microsoft.DataFactory/factories/querytriggerruns/read",
      "Microsoft.DataFactory/factories/querypipelineruns/read",
      "Microsoft.DataFactory/factories/pipelineruns/queryactivityruns/read",
      "Microsoft.DataFactory/factories/pipelines/pipelineruns/activityruns/progress/read",
      "Microsoft.DataFactory/operations/read",
      "Microsoft.DataFactory/checkazuredatafactorynameavailability/read",
      "Microsoft.DataFactory/locations/getFeatureValue/read",
      "Microsoft.DataFactory/factories/dataflows/read",
      "Microsoft.DataFactory/factories/dataflows/delete",
      "Microsoft.DataFactory/factories/dataflows/write",
      "Microsoft.DataFactory/factories/getFeatureValue/read",
      "Microsoft.DataFactory/factories/getDataPlaneAccess/read",
    ]
  }
}
